var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import Velocity from './index';
import { applyMixins, format } from '../utils';
var Compile = /** @class */ (function (_super) {
    __extends(Compile, _super);
    function Compile() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @param context {object} context object
     * @param macro   {object} self defined #macro
     * @param silent {bool} 如果是true，$foo变量将原样输出
     * @return str
     */
    Compile.prototype.render = function (context, macros, silence) {
        var _this = this;
        this.silence = !!silence;
        this.context = context || {};
        this.macros = Object.assign(macros || {}, {
            stop: function () {
                _this.runState.stop = true;
                return '';
            },
        });
        // eslint-disable-next-line no-prototype-builtins
        if (!this.macros.hasOwnProperty('eval')) {
            // add eval method to macros
            Object.defineProperty(this.macros, 'eval', {
                value: this.eval.bind(this),
            });
        }
        return this.renderAstList();
    };
    Compile.prototype.renderAstList = function (asts, contextId) {
        var _this = this;
        var str = '';
        asts = asts || this.asts;
        if (contextId) {
            if (contextId !== this.contextId && this.conditions.indexOf(contextId) === -1) {
                this.conditions.unshift(contextId);
            }
            this.contextId = contextId;
        }
        else {
            this.contextId = '';
        }
        asts.forEach(function (ast) {
            // 进入stop，直接退出
            if (_this.runState.stop === true) {
                return false;
            }
            switch (ast.type) {
                case 'references':
                    str += format(_this.getReferences(ast, true));
                    break;
                case 'set':
                    _this.setValue(ast);
                    break;
                case 'break':
                    _this.runState.break = true;
                    break;
                case 'macro_call':
                    str += _this.getMacro(ast);
                    break;
                case 'comment':
                    break;
                case 'raw':
                    str += ast.value;
                    break;
                default:
                    str += typeof ast === 'string' ? ast : _this.getBlock(ast);
                    break;
            }
        });
        return str;
    };
    return Compile;
}(Velocity));
export { Compile };
import './blocks';
import './expression';
import './literal';
import './references';
import './set';
applyMixins(Velocity, [Compile]);
//# sourceMappingURL=compile.js.map