var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { applyMixins } from '../utils';
import { Compile } from './compile';
/**
 * expression support, include math, logic, compare expression
 */
var Expression = /** @class */ (function (_super) {
    __extends(Expression, _super);
    function Expression() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * 表达式求值，表达式主要是数学表达式，逻辑运算和比较运算，到最底层数据结构，
     * 基本数据类型，使用 getLiteral求值，getLiteral遇到是引用的时候，使用
     * getReferences求值
     */
    Expression.prototype.getExpression = function (ast) {
        if (ast.type !== 'math') {
            return this.getLiteral(ast);
        }
        var exp = ast.expression;
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        var ret;
        switch (ast.operator) {
            case '+':
                ret = this.getExpression(exp[0]) + this.getExpression(exp[1]);
                break;
            case '-':
                ret = this.getExpression(exp[0]) - this.getExpression(exp[1]);
                break;
            case '/':
                ret = this.getExpression(exp[0]) / this.getExpression(exp[1]);
                break;
            case '%':
                ret = this.getExpression(exp[0]) % this.getExpression(exp[1]);
                break;
            case '*':
                ret = this.getExpression(exp[0]) * this.getExpression(exp[1]);
                break;
            case '||':
                ret = this.getExpression(exp[0]) || this.getExpression(exp[1]);
                break;
            case '&&':
                ret = this.getExpression(exp[0]) && this.getExpression(exp[1]);
                break;
            case '>':
                ret = this.getExpression(exp[0]) > this.getExpression(exp[1]);
                break;
            case '<':
                ret = this.getExpression(exp[0]) < this.getExpression(exp[1]);
                break;
            case '==':
                // eslint-disable-next-line eqeqeq
                ret = this.getExpression(exp[0]) == this.getExpression(exp[1]);
                break;
            case '>=':
                ret = this.getExpression(exp[0]) >= this.getExpression(exp[1]);
                break;
            case '<=':
                ret = this.getExpression(exp[0]) <= this.getExpression(exp[1]);
                break;
            case '!=':
                // eslint-disable-next-line eqeqeq
                ret = this.getExpression(exp[0]) != this.getExpression(exp[1]);
                break;
            case 'minus':
                ret = -this.getExpression(exp[0]);
                break;
            case 'not':
                ret = !this.getExpression(exp[0]);
                break;
            case 'parenthesis':
                ret = this.getExpression(exp[0]);
                break;
            default:
                return;
            // code
        }
        return ret;
    };
    return Expression;
}(Compile));
export { Expression };
applyMixins(Compile, [Expression]);
//# sourceMappingURL=expression.js.map