var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { applyMixins } from '../utils';
import { Compile } from './compile';
/**
 * #set value
 */
var SetValue = /** @class */ (function (_super) {
    __extends(SetValue, _super);
    function SetValue() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * get variable from context, if run in block, return local context, else return global context
     */
    SetValue.prototype.getContext = function (idName) {
        var local = this.local;
        // context find, from the conditions stack top to end
        for (var _i = 0, _a = this.conditions; _i < _a.length; _i++) {
            var condition = _a[_i];
            // eslint-disable-next-line no-prototype-builtins
            if (local[condition].hasOwnProperty(idName)) {
                return local[condition];
            }
        }
        // not find local variable, return global context
        return this.context;
    };
    /**
     * parse #set
     */
    SetValue.prototype.setValue = function (ast) {
        var _this = this;
        var _a, _b;
        var ref = ast.equal[0];
        var context = this.getContext(ref.id);
        // @see #25
        if (this.contextId && this.contextId.indexOf('macro:') === 0) {
            context = this.context;
            // fix #129
        }
        var valAst = ast.equal[1];
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        var val;
        if (valAst.type === 'math') {
            val = this.getExpression(valAst);
        }
        else {
            val = (_b = (_a = this.config).valueMapper) === null || _b === void 0 ? void 0 : _b.call(_a, this.getLiteral(ast.equal[1]));
        }
        if (!ref.path) {
            context[ref.id] = val;
            return;
        }
        var baseRef = context[ref.id];
        if (typeof baseRef !== 'object') {
            baseRef = {};
        }
        context[ref.id] = baseRef;
        var len = ref.path ? ref.path.length : 0;
        ref.path.some(function (exp, i) {
            var isEnd = len === i + 1;
            var key = exp.type === 'property' ? exp.id : '';
            if (exp.type === 'index' && exp.id) {
                key = _this.getLiteral(exp.id);
            }
            if (isEnd) {
                return (baseRef[key] = val);
            }
            baseRef = baseRef[key];
            // such as
            // #set($a.d.c2 = 2)
            // but $a.d is undefined , value set fail
            if (baseRef === undefined) {
                return true;
            }
        });
    };
    return SetValue;
}(Compile));
export { SetValue };
applyMixins(Compile, [SetValue]);
//# sourceMappingURL=set.js.map